#ifdef GLOBAL
#include <errno.h>
#include <stdlib.h>
       #include <sys/types.h>
              #include <sys/stat.h>
                     #include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/time.h>

     #include <sys/types.h>
     #include <unistd.h>
     #include <stdio.h>
     #include <stdlib.h>
     #include <fcntl.h>
       #include <sys/types.h>
              #include <signal.h>

extern Editor	*newfile(const char *);


#define DEBUG(x) 

pid_t gdbpid=0;
#define READ 0
#define WRITE 1
int tochild[2]={0,0};
int fromchild[2]={0,0};
char lookfile[]=EXAMPLEDIR "/look";
   #include <string.h>
struct sigaction oldsact,newsact;
void pipehandler(int signr) {
	if(gdbpid) {
		close(tochild[WRITE]);
		close(fromchild[READ]);
		kill(gdbpid,9);
		}
	gdbpid=0;
	signal(signr,oldsact.sa_handler);
	}
#endif



#ifdef EDITOR





#define fprintf(x,y...) {message(##y);erefresh();}


     /* Read characters from the pipe and echo them to `stdout'. */
//#define DEBUG(x) write(STDERR_FILENO,x,strlen(x));
int startup (void) {
	newsact.sa_handler=pipehandler;
	sigaction(SIGPIPE,&newsact,&oldsact);
     	if(pipe(tochild)==-1) 
     		return -1;
     	if(pipe(fromchild)==-1) 
     		return -1;
     	message("Starting gdb. Wait ...");
     	erefresh();
       gdbpid = fork ();
       if (gdbpid == (pid_t) 0)
         {
	close(tochild[WRITE]);
	close(fromchild[READ]);
         close(STDIN_FILENO);
         if(  dup(tochild[READ])<0) {

         	fprintf(stderr,"dup2(tochild[READ],STDIN_FILENO)<0 failt: %s", sys_errlist[errno] );
         	return -1;
          	}
          close(STDOUT_FILENO);
          if(dup(fromchild[WRITE])<0) {
         	fprintf(stderr,"dup2(fromchild[WRITE],STDOUT_FILENO)<0 failt: %s", sys_errlist[errno] );
         	return -1;
          	}
         if(execlp("gdb","bedit.gdb",lookfile, "-q",NULL)<0) {
         	fprintf(stderr,"execlp: %s", sys_errlist[errno] );
         	return -1;
           	}
           return -1;
         }
       else if (gdbpid < (pid_t) 0)
         {
           /* The fork failed. */
           fprintf (stderr, "Fork failed.");
           return -1;
         }
       else
         {
         int size,bufsize=1024,i,oldflags;
         char buf[bufsize];
	 char breaks[]="break main\n";
	 char run[]="run\n";
	 close(tochild[READ]);
	 close(fromchild[WRITE]);
	size=read(fromchild[READ],buf,bufsize);
	while(size==0) {
		write(tochild[WRITE],run,strlen(run));
		size=read(fromchild[READ],buf,bufsize);
		}; 
	if(size<0){
		fprintf(stderr,"gdb doesn't answer");
		return -1;
		}
	if(strncmp(buf,"(gdb)",5)) {
		message("gdb doesn't start with (gdb)");
		return -1;
		}
	write(tochild[WRITE],breaks,strlen(breaks));
	size=read(fromchild[READ],buf,bufsize);
	if(size<0) {
		message("failt reading from gdb pid=%d",gdbpid);
		return -1;
		}
	if(strncmp("Breakpoint",buf,10)) {
		fprintf(stderr,"Failt setting breakpoint");
		return -1;
		}
	buf[size]='\0';
	while(!strstr(buf,"(gdb)")) {
		size+=read(fromchild[READ],buf+size,bufsize);
		buf[size]='\0';
		}

	write(tochild[WRITE],run,strlen(run));
	size=read(fromchild[READ],buf,bufsize);
	if(size<0) {
		message("failt reading from gdb pid=%d",gdbpid);
		return -1;
		}
	if(strncmp("Starting",buf,8)){
		fprintf(stderr,"Cant execute help program");
		return -1;
		}
	buf[size]='\0';
	while(!strstr(buf,"(gdb)")) {
		size+=read(fromchild[READ],buf+size,bufsize);
		buf[size]='\0';
		}
	DEBUG("END Startup")
	return 0;
         }
      return -1;
     }
int gdbsane(void) {
	int bufsize=1024,size;
	char out[]="ptype cursor\n";
	char in[]="type = long",*res;
	char buf[bufsize];
         if(!gdbpid) {
			if(startup()<0)  {
				close(tochild[WRITE]);
				close(fromchild[READ]);
				if(gdbpid) {
					kill(gdbpid,9);
					}
				gdbpid=0;
				return -1;
				}
         	}
        lseek(fromchild[READ],0L,SEEK_END);
	write(tochild[WRITE],out,strlen(out));
	size=read(fromchild[READ],buf,bufsize);
	if(size<0) {
		message("gdbsane: failt reading from gdb pid=%d. Try again",gdbpid);
		return -1;
		}
	buf[size]='\0';
	while(!strstr(buf,"(gdb)")) {
		size+=read(fromchild[READ],buf+size,bufsize);
		buf[size]='\0';
		}
	res= strstr(buf,in);
	if(!res)
		message("%s in stead of \'type = long\'",buf);
	return 0;
	}

int gdbagain(char *inp) {
	int size,bufsize=1024;
         char buf[bufsize],*ptr,*start,*end;
         if(gdbsane()!=0) {
         	return -1;
         	}
	unsigned long *gegs=(unsigned long *)inp;

	sprintf( buf,"p cursor[0]=0x%x\np cursor[1]=0x%x\np cursor[2]=0x%x\np cursor[3]=0x%x\np cursor[4]=0x%x\ndisassemble cursor cursor+4\n",gegs[0],gegs[1],gegs[2],gegs[3],gegs[4]);
	write(tochild[WRITE],buf,strlen(buf));
	ptr=NULL;
	DEBUG("before read")
	start=buf;
	while(((size=read(fromchild[READ],start,bufsize))>=0)) {
//		write(STDOUT_FILENO,buf,size);
		start=start+size;
		start[0]='\0';
	//	DEBUG(buf)
		if((ptr=strstr(buf,"End of assembler dump.")))
			break;
		}
	if(ptr) {
		int len=0xffff;
		start=strstr(buf,"Dump of assembler code from");
		start=index(start,':')+2;
		end=index(start,'>');
		ptr=index(end,'\n');
		*ptr++='\0';
		if((ptr=index(ptr,'+'))) 
			sscanf(++ptr,"%d",&len);
		if((end=index(end,'<'))&& (ptr=index(end,'>'))) {
			*end='\0';
			message("%s%s		(%d bytes)",start,++ptr,len);
			}
		else	
			message("%s		(%d bytes)",start,len);
		}
	DEBUG("end gdbagain")
	return 0;
	}



#define TAKE 25

int gdb(void) {
	char buf[TAKE];
	memset(buf,'\0',TAKE);
	getmem(getfilepos()+geteditpos(),  buf,TAKE); 
	if(gdbagain(buf)<0)
		message("Is %s on the right place and compiled with -g?",lookfile);
	};

#endif


call(gdb)
